require 'active_support/inflector'

class Class
  def spigit_attr(java_key, *aliases)
    java_key = java_key.to_s
    name     = java_key.underscore

    self.class_eval(%Q{
      def #{name}
        if node_exists?("#{java_key}")
          node = get_node("#{java_key}")
          node.text
        end
      end
    })

    self.class_eval(%Q{
      def #{name}=(val)
        if node_exists?("#{java_key}")
          node = get_node("#{java_key}")
        else
          node = add_config("#{java_key}")
        end

        node.content = val
      end
    })

    aliases.each do |x|
      x = x.to_s

      self.class_eval(%Q{
        alias_method :#{x}, :#{name}
        alias_method :#{x}=, :#{name}=
      })
    end

  end
end
